#include "angband.h"
#include "cmd-spell.h"
#include "selfinfo.h"

/*!
* @brief p̈斂@̊es
* @param spell @ID
* @param mode e (SPELL_NAME / SPELL_DESC / SPELL_INFO / SPELL_CAST)
* @return SPELL_NAME / SPELL_DESC / SPELL_INFO ɂ͕|C^ԂBSPELL_CASTNULLԂB
*/
cptr do_sorcery_spell(SPELL_IDX spell, BIT_FLAGS mode)
{
	bool name = (mode == SPELL_NAME) ? TRUE : FALSE;
	bool desc = (mode == SPELL_DESC) ? TRUE : FALSE;
	bool info = (mode == SPELL_INFO) ? TRUE : FALSE;
	bool cast = (mode == SPELL_CAST) ? TRUE : FALSE;

	int dir;
	int plev = p_ptr->lev;

	switch (spell)
	{
	case 0:
		if (name) return _("X^[m", "Detect Monsters");
		if (desc) return _("߂̑SĂ̌郂X^[mB", "Detects all monsters in your vicinity unless invisible.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_monsters_normal(rad);
			}
		}
		break;

	case 1:
		if (name) return _("V[gEe|[g", "Phase Door");
		if (desc) return _("ߋ̃e|[gB", "Teleport short distance.");

		{
			POSITION range = 10;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 2:
		if (name) return _("㩂Ɣm", "Detect Doors and Traps");
		if (desc) return _("߂̑SĂ̔㩂mB", "Detects traps, doors, and stairs in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_traps(rad, TRUE);
				detect_doors(rad);
				detect_stairs(rad);
			}
		}
		break;

	case 3:
		if (name) return _("CgEGA", "Light Area");
		if (desc) return _("Ƃ炵Ă͈͂Ŝivɖ邭B", "Lights up nearby area and the inside of a room permanently.");

		{
			int dice = 2;
			int sides = plev / 2;
			int rad = plev / 10 + 1;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				lite_area(damroll(dice, sides), rad);
			}
		}
		break;

	case 4:
		if (name) return _("pjbNEX^[", "Confuse Monster");
		if (desc) return _("X^[1̂BRƖB", "Attempts to confuse a monster.");

		{
			int power = (plev * 3) / 2;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				confuse_monster(dir, power);
			}
		}
		break;

	case 5:
		if (name) return _("e|[g", "Teleport");
		if (desc) return _("̃e|[gB", "Teleport long distance.");

		{
			POSITION range = plev * 5;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 6:
		if (name) return _("X[vEX^[", "Sleep Monster");
		if (desc) return _("X^[1̂𖰂点BRƖB", "Attempts to sleep a monster.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				sleep_monster(dir, plev);
			}
		}
		break;

	case 7:
		if (name) return _("͏[U", "Recharging");
		if (desc) return _("/@_̏[U񐔂𑝂₷A[Ũbh̏[UԂ炷B", "Recharges staffs, wands or rods.");

		{
			int power = plev * 4;

			if (info) return info_power(power);

			if (cast)
			{
				if (!recharge(power)) return NULL;
			}
		}
		break;

	case 8:
		if (name) return _("@̒n}", "Magic Mapping");
		if (desc) return _("ӂ̒n`mB", "Maps nearby area.");

		{
			int rad = DETECT_RAD_MAP;

			if (info) return info_radius(rad);

			if (cast)
			{
				map_area(rad);
			}
		}
		break;

	case 9:
		if (name) return _("Ӓ", "Identify");
		if (desc) return _("ACeʂB", "Identifies an item.");

		{
			if (cast)
			{
				if (!ident_spell(FALSE)) return NULL;
			}
		}
		break;

	case 10:
		if (name) return _("XEEX^[", "Slow Monster");
		if (desc) return _("X^[1̂BRƖB", "Attempts to slow a monster.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				slow_monster(dir, plev);
			}
		}
		break;

	case 11:
		if (name) return _("ӃX[v", "Mass Sleep");
		if (desc) return _("ȆSẴX^[𖰂点BRƖB", "Attempts to sleep all monsters in sight.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				sleep_monsters(plev);
			}
		}
		break;

	case 12:
		if (name) return _("e|[gEX^[", "Teleport Away");
		if (desc) return _("X^[e|[gr[BRƖB", "Teleports all monsters on the line away unless resisted.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_beam(GF_AWAY_ALL, dir, power);
			}
		}
		break;

	case 13:
		if (name) return _("Xs[h", "Haste Self");
		if (desc) return _("莞ԁAB", "Hastes you for a while.");

		{
			int base = plev;
			int sides = 20 + plev;

			if (info) return info_duration(base, sides);

			if (cast)
			{
				set_fast(randint1(sides) + base, FALSE);
			}
		}
		break;

	case 14:
		if (name) return _("^Em", "Detection True");
		if (desc) return _("߂̑SẴX^[A㩁AAKiAAăACemB",
			"Detects all monsters, traps, doors, stairs, treasures and items in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_all(rad);
			}
		}
		break;

	case 15:
		if (name) return _("^EӒ", "Identify True");
		if (desc) return _("ACe̎\͂SɒmB", "*Identifies* an item.");

		{
			if (cast)
			{
				if (!identify_fully(FALSE)) return NULL;
			}
		}
		break;

	case 16:
		if (name) return _("̂ƍ󊴒m", "Detect items and Treasure");
		if (desc) return _("߂̑SẴACeƍmB", "Detects all treasures and items in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_objects_normal(rad);
				detect_treasure(rad);
				detect_objects_gold(rad);
			}
		}
		break;

	case 17:
		if (name) return _("`[EX^[", "Charm Monster");
		if (desc) return _("X^[1̂𖣗BRƖB", "Attempts to charm a monster.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				charm_monster(dir, power);
			}
		}
		break;

	case 18:
		if (name) return _("_m", "Sense Minds");
		if (desc) return _("莞ԁAepV[\͂𓾂B", "Gives telepathy for a while.");

		{
			int base = 25;
			int sides = 30;

			if (info) return info_duration(base, sides);

			if (cast)
			{
				set_tim_esp(randint1(sides) + base, FALSE);
			}
		}
		break;

	case 19:
		if (name) return _("Xړ", "Teleport to town");
		if (desc) return _("XֈړBnɂƂgȂB", "Teleport to a town which you choose in a moment. Can only be used outdoors.");

		{
			if (cast)
			{
				if (!tele_town()) return NULL;
			}
		}
		break;

	case 20:
		if (name) return _("ȕ", "Self Knowledge");
		if (desc) return _("݂̎̏ԂSɒmB",
			"Gives you useful info regarding your current resistances, the powers of your weapon and maximum limits of your stats.");

		{
			if (cast)
			{
				self_knowledge();
			}
		}
		break;

	case 21:
		if (name) return _("e|[gEx", "Teleport Level");
		if (desc) return _("uɏォ̊KɃe|[gB", "Teleport to up or down stairs in a moment.");

		{
			if (cast)
			{
				if (!get_check(_("{ɑ̊KɃe|[g܂H", "Are you sure? (Teleport Level)"))) return NULL;
				teleport_level(0);
			}
		}
		break;

	case 22:
		if (name) return _("A҂̎", "Word of Recall");
		if (desc) return _("nɂƂ̓_W̍Ő[KցA_WɂƂ͒nւƈړB",
			"Recalls player from dungeon to town, or from town to the deepest level of dungeon.");

		{
			int base = 15;
			int sides = 20;

			if (info) return info_delay(base, sides);

			if (cast)
			{
				if (!word_of_recall()) return NULL;
			}
		}
		break;

	case 23:
		if (name) return _("̔", "Dimension Door");
		if (desc) return _("Z̎w肵ꏊɃe|[gB", "Teleport to given location.");

		{
			POSITION range = plev / 2 + 10;

			if (info) return info_range(range);

			if (cast)
			{
				msg_print(_("̔JBړInIŉB", "You open a dimensional gate. Choose a destination."));
				if (!dimension_door()) return NULL;
			}
		}
		break;

	case 24:
		if (name) return _("", "Probing");
		if (desc) return _("X^[̑Ać̗Aő̗́AXs[hÂmB",
			"Proves all monsters' alignment, HP, speed and their true character.");

		{
			if (cast)
			{
				probing();
			}
		}
		break;

	case 25:
		if (name) return _("̃[", "Explosive Rune");
		if (desc) return _("̂鏰̏ɁAX^[ʂƔă_[W^郋[`B",
			"Sets a glyph under you. The glyph will explode when a monster moves on it.");

		{
			int dice = 7;
			int sides = 7;
			int base = plev;

			if (info) return info_damage(dice, sides, base);

			if (cast)
			{
				explosive_rune();
			}
		}
		break;

	case 26:
		if (name) return _("O", "Telekinesis");
		if (desc) return _("ACȇֈړB", "Pulls a distant item close to you.");

		{
			int weight = plev * 15;

			if (info) return info_weight(weight);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fetch(dir, weight, FALSE);
			}
		}
		break;

	case 27:
		if (name) return _("痢", "Clairvoyance");
		if (desc) return _("̊KŜivɏƂ炵A_WׂẴACemBɁA莞ԃepV[\͂𓾂B",
			"Maps and lights whole dungeon level. Knows all objects location. And gives telepathy for a while.");

		{
			int base = 25;
			int sides = 30;

			if (info) return info_duration(base, sides);

			if (cast)
			{
				chg_virtue(V_KNOWLEDGE, 1);
				chg_virtue(V_ENLIGHTEN, 1);

				wiz_lite(FALSE);

				if (!p_ptr->telepathy)
				{
					set_tim_esp(randint1(sides) + base, FALSE);
				}
			}
		}
		break;

	case 28:
		if (name) return _("̎", "Charm monsters");
		if (desc) return _("ȆSẴX^[𖣗BRƖB", "Attempts to charm all monsters in sight.");

		{
			int power = plev * 2;

			if (info) return info_power(power);

			if (cast)
			{
				charm_monsters(power);
			}
		}
		break;

	case 29:
		if (name) return _("Bp", "Alchemy");
		if (desc) return _("ACe1ɕςB", "Turns an item into 1/3 of its value in gold.");

		{
			if (cast)
			{
				if (!alchemy()) return NULL;
			}
		}
		break;

	case 30:
		if (name) return _("Ǖ", "Banishment");
		if (desc) return _("ȆSẴX^[e|[gBRƖB", "Teleports all monsters in sight away unless resisted.");

		{
			int power = plev * 4;

			if (info) return info_power(power);

			if (cast)
			{
				banish_monsters(power);
			}
		}
		break;

	case 31:
		if (name) return _("̋", "Globe of Invulnerability");
		if (desc) return _("莞ԁA_[W󂯂ȂȂoA𒣂B؂ꂽuԂɏ^[̂ŒӁB",
			"Generates barrier which completely protect you from almost all damages. Takes a few your turns when the barrier breaks or duration time is exceeded.");

		{
			int base = 4;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_invuln(randint1(base) + base, FALSE);
			}
		}
		break;
	}

	return "";
}
